config/routes.rb
require 'sidekiq/web'

Rails.application.routes.draw do

  root to: 'pages#landing'

  get '/about', to: 'pages#about', as: :about
  get '/tos', to: 'pages#tos', as: :tos
  get '/demo', to: 'pages#demo', as: :demo

  get '/badness/:secret', to: 'pages#badness'

  match '/404', to: 'pages#not_found', via: :all
  match '/422', to: 'pages#unacceptable', via: :all
  match '/500', to: 'pages#internal_error', via: :all

  match '/wiki' => redirect('https://github.com/Gamocosm/Gamocosm/wiki'), as: :wiki, via: :get
  match '/issues' => redirect('https://github.com/Gamocosm/Gamocosm/issues'), as: :issues, via: :get
  match '/source' => redirect('https://github.com/Gamocosm/Gamocosm'), as: :source, via: :get
  match '/git_head' => redirect("https://github.com/Gamocosm/Gamocosm/tree/#{Gamocosm::GIT_HEAD}"), as: :git_head, via: :get
  match '/license' => redirect('https://github.com/Gamocosm/Gamocosm/blob/master/LICENSE'), as: :license, via: :get
  match '/blog' => redirect('http://gamocosm.com/blog/'), as: :blog, via: :get
  match '/irc' => redirect('https://webchat.esper.net/?channels=gamocosm'), as: :irc, via: :get
  match '/irc_history' => redirect('http://irc.gamocosm.com'), as: :irc_history, via: :get

  scope '/wiki' do
    match '/ftp_ssh' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/FTP-and-SSH'), as: :wiki_ftp_ssh, via: :get
    match '/minecraft_versions' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Installing-different-versions-of-Minecraft'), as: :wiki_minecraft_versions, via: :get
    match '/server_advanced_tab' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Server-advanced-tab-documentation'), as: :wiki_server_advanced_tab, via: :get
    match '/server_additional_info' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Additional-Info-for-Server-Admins'), as: :wiki_server_additional_info, via: :get
    match '/troubleshooting' => redirect('https://github.com/Gamocosm/Gamocosm/wiki/Troubleshooting'), as: :wiki_troubleshooting, via: :get
  end

  scope '/digital_ocean' do
    get '/setup', to: 'pages#digital_ocean_setup', as: :digital_ocean_setup

    match '/index' => redirect('https://www.digitalocean.com/?refcode=f787055e1099'), as: :digital_ocean_index, via: :get
    match '/index_no_ref' => redirect('https://www.digitalocean.com/'), as: :digital_ocean_index_no_ref, via: :get
    match '/pricing' => redirect('https://www.digitalocean.com/pricing/?refcode=f787055e1099'), as: :digital_ocean_pricing, via: :get
    match '/pricing_no_ref' => redirect('https://www.digitalocean.com/pricing/'), as: :digital_ocean_pricing_no_ref, via: :get
    match '/help' => redirect('https://www.digitalocean.com/help/'), as: :digital_ocean_help, via: :get
    match '/control_panel' => redirect('https://cloud.digitalocean.com'), as: :digital_ocean_control_panel, via: :get
    match '/status' => redirect('https://status.digitalocean.com'), as: :digital_ocean_status, via: :get

    get 'droplets', to: 'servers#show_digital_ocean_droplets', as: :show_digital_ocean_droplets
    delete 'droplets/:id', to: 'servers#destroy_digital_ocean_droplet', as: :destroy_digital_ocean_droplet
    get 'snapshots', to: 'servers#show_digital_ocean_snapshots', as: :show_digital_ocean_snapshots
    delete 'snapshots/:id', to: 'servers#destroy_digital_ocean_snapshot', as: :destroy_digital_ocean_snapshot
    get 'ssh_keys', to: 'servers#show_digital_ocean_ssh_keys', as: :show_digital_ocean_ssh_keys
    post 'ssh_keys', to: 'servers#add_digital_ocean_ssh_key', as: :add_digital_ocean_ssh_key
    delete 'ssh_keys/:id', to: 'servers#destroy_digital_ocean_ssh_key', as: :destroy_digital_ocean_ssh_key
    delete 'cache', to: 'servers#refresh_digital_ocean_cache', as: :refresh_digital_ocean_cache
  end

  scope '/external' do
    match '/github_student_developer_pack' => redirect('https://education.github.com/pack'), as: :external_github_student_developer_pack, via: :get
  end

  scope '/cuberite' do
    match '/' => redirect('http://cuberite.org'), as: :cuberite_website, via: :get
    match '/repo' => redirect('https://github.com/cuberite/cuberite'), as: :cuberite_repo, via: :get
  end

  Sidekiq::Web.use Rack::Auth::Basic, 'Protected Area' do |u, p|
    u == Gamocosm::SIDEKIQ_ADMIN_USERNAME && p == Gamocosm::SIDEKIQ_ADMIN_PASSWORD
  end
  mount Sidekiq::Web => '/sidekiq'

  devise_for :users, controllers: { registrations: 'registrations' }

  resources :servers, path: '/servers' do
    collection do
      post 'new', to: 'servers#create', as: :create
    end
    member do
      get 'delete'
      get 'start'
      get 'stop'
      get 'pause'
      get 'resume'
      get 'backup'
      get 'download'
      get 'reboot'
      put 'update_properties'
      post 'add_friend'
      post 'remove_friend'
      post 'command'
      get 'autoshutdown_enable'
      get 'autoshutdown_disable'
      get 'clear_logs'
    end
  end

end

app/views/layouts/components/_flash.html.erb
<div class="container">
  <% flash.each do |name, msg| %>
    <div class="flash-container row">
      <div class="alert alert-dismissable alert-<%= if name == 'error' then 'danger' elsif name == 'notice' then 'info' elsif name == 'alert' then 'warning' else name end %>">
        <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
        <%= msg %>
      </div>
    </div>
  <% end %>
</div>

app/views/layouts/components/_footer.html.erb
<footer id="footer">
	<div class="container">
		<div class="row">
			<div class="col-sm-offset-2 col-sm-2 text-muted">
				<ul>
					<li><b><%= link_to 'Home', root_url %></b></li>
					<li><%= link_to 'About', about_path %></li>
					<li><%= link_to 'Wiki', wiki_path %></li>
					<li><%= link_to 'Blog and updates', blog_path %></li>
				</ul>
			</div>
			<div class="col-sm-2 text-muted">
				<ul>
					<li><b>Contact</b></li>
					<li><%= link_to 'GitHub issues', issues_path %></li>
					<li><%= link_to 'IRC web chat', irc_path %></li>
					<li><%= link_to 'IRC chat history', irc_history_path %></li>
				</ul>
			</div>
			<div class="col-sm-2 text-muted">
				<ul>
					<li><b>Digital Ocean</b></li>
					<li><%= render_digital_ocean_referral_link('%s (%s)', 'Website', digital_ocean_index_path, digital_ocean_index_no_ref_path) %></li>
					<li><%= render_digital_ocean_referral_link('%s (%s)', 'Pricing', digital_ocean_pricing_path, digital_ocean_pricing_no_ref_path) %></li>
					<li><%= link_to 'Setup', digital_ocean_setup_path %></li>
				</ul>
			</div>
			<div class="col-sm-2 text-muted">
				<ul>
					<li><b>Miscellaneous</b></li>
					<li><%= link_to 'Source code', source_path %></li>
					<li><%= link_to 'Terms of service', tos_path %></li>
					<li><%= link_to 'Sign up', new_user_registration_path %></li>
				</ul>
			</div>
		</div>
		<br />
		<div class="row">
			<div class="col-sm-12">
				<p class="copyright text-muted small">
					Design by <a href="https://mingard.io">Jono Mingard</a>
					<br />
					Server running commit <%= link_to Gamocosm::GIT_HEAD, git_head_path %> from <%= Gamocosm::GIT_HEAD_DATE %>
					<br />
					Copyright Gamocosm 2014 - <%= Date.today.year %>. All Rights Reserved
				</p>
			</div>
		</div>
	</div>
</footer>

app/views/layouts/components/_navbar.html.erb
<nav class="navbar navbar-default navbar-fixed-top" role="navigation">
  <div class="container">
    <div class="navbar-header">
      <button type="button" class="navbar-toggle" data-toggle="collapse" data-target="#navbar-collapse-0">
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <%= link_to root_url, class: 'navbar-brand' do %>
        <%= inline_svg 'logo.svg' %> Gamocosm
      <% end %>
    </div>
    <div class="collapse navbar-collapse" id="navbar-collapse-0">
      <ul class="nav navbar-nav">
        <li><%= link_to 'About', about_path %></li>
        <li><%= link_to 'Wiki', wiki_path %></li>
        <li><%= link_to 'Blog and Updates', blog_path %></li>
      </ul>
      <ul class="nav navbar-nav navbar-right">
        <% if begin user_signed_in? rescue false end %>
          <li><%= link_to 'Servers', servers_path %></li>
          <li><%= link_to 'Settings', edit_user_registration_path %></li>
          <li><%= link_to 'Logout', destroy_user_session_path, method: :delete %></li>
        <% else %>
          <li><%= link_to 'Sign up', new_user_registration_path %></li>
          <li><%= link_to 'Login', new_user_session_path %></li>
        <% end %>
      </ul>
    </div>
  </div>
</nav>